Subject: [nfsv4] Review comments for Locking and Directory DelegationsReview # 3

From: "Khan, Saadia" <[email-masked]>
Date: Tue, 4 Sep 2007 16:54:12 -0700

The third review meeting for locking and directory delegations was held
on September 4, 2007.
 
The roles in this meeting were:

- moderator - Shepler

- reader - Eisler

- scribe - Khan

- author - Noveck

- inspectors: Erasani, Gordon, Kustarz

In this meeting, we covered lines 10547 - 10560, 13332 - 13478, 24310 -
24588, 25788 - 25994 and 26044 - 26159 from draft 13.

I am listing the review comments received during the review by name,
line number and comment.
 
lines 10547 - 10560
 
Eisler - L 10555 - It should be mentioned that this operation is valid
for all file types except dirs.
 
Khan - L 10557 - lock state should be mentioned here as well.
 
Eisler - Also mention that callbacks can be done in case the delegation
is not immediately available.
 
Ersani - Clarified that this op can be issued at reclaim time as well.
 
lines 13332 - 13478
 
Eisler - Delegation related text should be in the caching chapter.
 
Eisler - L 13412 - s/nfsv4/nfsv4.1
 
Eisler - L 13411 - Clarify by mentioning that the only way to avoid
delegation recall is to make changes through a session associated with
the clientid.
 
Eisler - L 13416 - add that this is true only if notifications are
requested by the client.
 
Eisler - L 13426 - add the third case where multiple clients hold
delegations and one client makes the changes.
 
Eisler - L 13452 - mention CB_RECALL here
 
Eisler - L 13456 - Remove the line starting with 'Also if .."
 
Saadia - L 13463 - Remove this paragraph.
 
Noveck - L 13477 - yes, the state should be removed.
 
lines 24310 - 24588
 
Noveck - L 24312 - s/test/free one
 
Eisler - L 24353 - It should be mentioned in the implementation section
that the client should test the stateid before freeing it.
 
Noveck - L 24336 - Add device id mapping here if there is consensus on
that issue.
 
Khan - L 24341 - Divide this up into multiple sentences for clarity.
 
Eisler - L 24371 - remove (cfh)
 
Eisler - L 24386 - change to be a bitmap instead.
 
Noveck - L 24461 - remove 'also'
 
Khan - L 24467 - delete the last sentence
 
Eisler - L 24479 - remove the part about cookie verifier
 
Eisler - specific args/response fields should be referenced in this
section
 
Khan - L 24493 - Lines starting from here in this paragraph should be
moved to the implementation section and '..' should be changed to
parent.
 
Noveck -  L 24499 - Clarify that an error is not returned if a callback
will be done when the delegation becomes available. Also note that if
the server decides not to send a notification then it can set
deleg_avail to FALSE and return DLG_UNAVIL.
 
Gordon - The server should not add bits to the supported notifications
bitmask that the client did not ask for.
 
Khan - L 24504 - Also mention that if the delegation is available, the
server might decide to give it to the client instead of doing a callback
later.
 
Noveck - L 24499 - Look into "want" and decide if the semantics are the
same as want_delegation and if so clarify that. Also look into whether
this 'want' can be cancelled through the cb_wants_canelled op.
 
Khan - L 24519 - s/flags/bits
 
Eisler - L 24520 - s/direction/directory
 
Khan - L 24541 - change 'appropriately' to mention what should be set
here.
 
 Eisler - L 24588 - reference the section on security negotiations here.
 
Khan - L 24588 - This should be clarified and it should not say anything
about setting hte cfh.
 
lines 25788 - 25994
 
Gordon - L 25794 - s/error_codes<>/status_codes<>
 
Eisler - L 25839 - some examples and reference to the sequence op needed
here.
 
Eisler - L 25844 - s/provides/returns
 
Eisler - L 25847 - s/cause processing/cause compound processing
 
Dave/Mike/Saadia - L 25855 - Add old_stateid and stale_stateid as valid
errors. Also add EInval for special stateids.
 
Eilser/Kustarz - Reference the stateid generation section in the
implementation section. 
 
Eisler - L 25865 - remove (client ID)
 
Eisler - L 25943 - It should also mention here that the server might
decide to cancel the want by issuing a cb_wants_cancelled operation.
 
Khan - L 25945 - Clarification needed that in this case the server will
not set the bit that tells the client that the server will callback,
x-ref the open section here.
 
Eisler - L 25955 - The flags here should be indented.
 
Noveck - L 25972 - This discussion should be moved to the implementation
section. It should probably say that the delegation should not be
recalled in case of a conflict but its upto the server to decide.
 
Eisler - L 25978 - s/differences/difference
 
Khan - L 25988 - This combination should not be allowed and EINVAL
should be returned in this case.
 
Eisler - L 25994 - This part should mention when the delegation should
be recalled.
 
lines 26044 - 26159 
 
Khan - L 26074 - s/of/or
 
Eisler - L 26084 - s/fs/file system
 
Khan - L 26072 - It should be mentioned that the client MUST issue a
reclaim_complete when its done.
 
Eisler - L 26103 - s/must/MUST
 
Eisler - L 26015/26113 - It should be mentioned here that if hte client
does a non-reclaim op before doing reclaim_complete, it should be
prepared for a grace error. Also even after doing a reclaim_complete,
the client should be prepared for a grace error since the server might
still not be out of its reclaim period.
 
Eisler - L 26116 - the two known edge conditions should be mentioned
here and x-referenced.
 
thanks.
Saadia
 
_______________________________________________
nfsv4 mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/nfsv4